﻿// ------ webRPG_main.js --------
// ------------------------------ javascript ------------------------------
'use strict';

//author: (C) 2020-2022 Joerg Liszkowski
// GPL

// ------- constanten -------
var Nunits=32; var NunitsA=16; // Anzahl insgesammt, davon Avatare (figure Datei in 2 Reihen)
// Nunits = 0...31 is Figuren, =32 ist Hintergrund !
var NwuerfelStart=6; // ab dieser "Zeile" in der Antwort sind es  Würfel/Chat strings
var Nwuerfel=NwuerfelStart+11; // so viele Zeilen Würfel/Chat Historie sind auf dem Server
var Ngui=16; // so viele GUI Elemente
var wuerfelB=17;

var SLmodus=false; // veralte, wird nicht mehr abgefragt
// ---------------------------------------------------------------------
var user='';
var defaultWstring ='1w20';
// ---------------------------------------------------------------------

//window.onload = function() {
function webRPG_mainOnload() {
	// ----------------------- gespeicherte Werte auslesen ----------------------------------------------
	if (sessionStorage.getItem('user') !== null) {user=sessionStorage.getItem('user'); }
	if (sessionStorage.getItem('defaultWstring') !== null) {defaultWstring=sessionStorage.getItem('defaultWstring'); }
	// "http://localhost:8080/web/webRPG_main.html?=defaultWstring=1w20&user=kuma" parsen
	const parsedUrl = new URL(window.location.href);
	// --- user ---
    if( parsedUrl.searchParams.get("user") !== null){ 
		user= parsedUrl.searchParams.get("user");
		sessionStorage.setItem('user', user);
		// console.log('user='); console.log(user);
	}
	// --- defaultWstring ---
    if( parsedUrl.searchParams.get("defaultWstring") !== null) { 
		defaultWstring= parsedUrl.searchParams.get("defaultWstring");
		sessionStorage.setItem('defaultWstring', defaultWstring);
	}
	// --- file ---
    if( parsedUrl.searchParams.get("file") !== null){
		//console.log('file=') ;	console.log(parsedUrl.searchParams.get("file"));
		// --- Daten an den Server senden --- 
		var filename=parsedUrl.searchParams.get("file");
		filename.replaceAll("~"," "); // "~" ist ein Trennzeichen -> im Dateinamen entfernen
		var daten = 'h~'+ filename;  // Type "h" + string mit dem Hintergrunddateinamen versenden
		setGameData.open("POST","webRPG_setGameData.php"); // PHP Version
		setGameData.send(daten);
	}
    
    // document.body.oncontextmenu = function() {return false}; // rechte Maustaste OHNE contextmenu vom Browser
	// ---------------------------------------------------------------------

    var gameWidth  = 2048;// 1280; // < 2048 !!!
    var gameHeight = 1024; // 720; // < 1024 !!!
    var parentElement = document.getElementById('ID_Spielfeld');
    var scene = sjs.Scene({w:gameWidth, h:gameHeight ,parent:parentElement });
    
    var bgLayer = scene.Layer("bgLayer");
    var gridLayer = scene.Layer("gridLayer");
    var playLayer = scene.Layer("playLayer");
    var guiLayer = scene.Layer("guiLayer");
    var interfaceLayer = scene.Layer("interfaceLayer");
    
	// bgLayer
    gridLayer.onTop();
    guiLayer.onTop();
    playLayer.onTop();
    interfaceLayer.onTop();

    var input  = scene.Input();
    
    // --- Hintergrund sprites ---
    if (filename === undefined ) { // || filename === null
		console.log('file= no File!') ;
		var hintergrund= scene.Sprite('daten/default_hintergrund.jpg', bgLayer);
		hintergrund.dateiname='default_hintergrund.jpg'; //  Hintergrundbilde 
	} else {
		console.log('file=') ;	console.log( filename+'?id='+getRndInteger(10000000000) );
		var hintergrund= scene.Sprite( filename+'?id='+getRndInteger(10000000000), bgLayer);
		hintergrund.dateiname = filename;
	}
	hintergrund.zoom=5;
	hintergrund.gridOnOff=0; // 0=off, 1=on
	hintergrund.Xoff=256;
	hintergrund.Yoff=32;
  	hintergrund.position( hintergrund.Xoff, hintergrund.Yoff );

	// --- Grid Layer sprites ---
	var gridElemente= scene.Sprite('gridElement.png', gridLayer);
	gridElemente.size(2048, 1024);
  	gridElemente.position( 256,2500 );
	gridElemente.EinAus=false;

  	var zaehlerElemente = zaehlerElementeInit(scene, guiLayer);
	var zaehler_dragNdrop=-1; 
	
	// --- guiLayer Layer = guiElemente sprites ---
    // Init der Toolbar (webRPG_toolbar.js)
    var guiElemente = toolbarInit(scene, interfaceLayer, SLmodus);
	var toolbar_dragNdrop = false;
	
	//  sprites anlegen für Auswahlfenster
	var unitsAussehen = figurenAussehenAuswahlInit(scene, interfaceLayer, SLmodus);
	var unitsAussehenEinAus=0; // 0 = Aus, 1= Units Aussehen, 2=Hintergrundwahl
    
    // --- Figuren sprites (Avatar) --- 
    var units = sjs.SpriteList();
    for (var i=0;i<Nunits;i++) {
        units[i] = scene.Sprite('daten/figuren.png' , playLayer); //?id='+getRndInteger(10000000000)
        units[i].setW(32);
        units[i].setXOffset(0); // offset ins PNG
        units[i].setYOffset(32*i); // offset ins PNG
        units[i].aussehen = i; // userData
        units[i].position(32+i , 32+i );
        units[i].size(32, 32);
        units[i].zoom = 1; // userData
	}
	// Position im Rechteck
	var xOff=32*7; var yOff=0+32*3;
	var index=0;
	for (var iy=0;iy<4;iy++) {
		for (var ix=0;ix<8;ix++) {
			if(index<Nunits) {
				units[index].defaultPosX = xOff-32*ix ;
				units[index].defaultPosY = yOff-32*iy;
				index=index+1;
			}
		}
	}
    // --- Figuren sprites (Marker) --- 
    for (var i=NunitsA;i<Nunits;i++) {
        units[i].setXOffset(32); // offset ins PNG
        units[i].setYOffset(32*(i-NunitsA) ); // offset ins PNG
	}
    // --- selection cursor, for collision ---
    var selCursor =  scene.Sprite(false,guiLayer);
    var units_blinken=-2; // Blinken aus
    var units_selected = -1; // unit -1, also keine ist ausgewählt
    var units_dragNdrop ={}; // struc erzeugen
	units_dragNdrop.nummer = -1; // unit -1, also keine, soll bewegt werden
	units_dragNdrop.xOff = -16; // offset für DragNdrop
	units_dragNdrop.yOff = -16; // offset für DragNdrop

	// Tip am Rande
	// scene.dom ist das HTML DOM (DokumentenObjekt) -> z.B. "scene.dom.div" die des <div ...></div> Elemente in dem die scene steckt

    // ---  timerReqGameData: sonst nichts los => 333ms bei Server nachfragen ---
    var timerReqGameData = 0 ; // 10 * 30 frames/s = 333ms
    var commitZahlerstandFigur = 0; // der Wert vom letzen commit das bekannt ist <-> erkennen ob neue Daten vorliegen oder nicht
    var commitZahlerstandWuerfel = 0; 
    var commitZahlerstandHintergrund = 0;
		
	// !!! Das muss noch im Kontext von "window.onload = function() {" sein
	// --------------------------------------------------------------------- 
	//  Server nach neuen Daten fragen  --- hier kommen die Antworten an
	// --------------------------------------------------------------------- 
	// Anfrage:  Flag; commit Zähler Figur ; commit Zähler Hintergrund-Dateiname ; Commit Zähler Würfelstring
	// Antwort ist:
	// Flag ; commit Zählerstand Figur ; 33 * units[] ; commit Zähler Hintergrund-Dateiname ; Dateinamestring; Commit Zählerstand Würfelstring ; 11*Würfelstring
	// mit: 33 * units[] Objekte: 
	//		"AzXXXyyy" A: Aussehen(Bit1-4), z: Zoomfaktor*2, XXX Koordinate, yyy Koordinate & Bit(5 & 6) vom Aussehen 
	// mit: Dateinamestring: String 
	// mit: Würfel String: "Fstring" mit F=Farbe, dann Ergebnis als String 
	
	var reqGameData = new XMLHttpRequest();
	reqGameData.addEventListener('load', reqGameData_callback);
	function reqGameData_callback() {
		if (reqGameData.status >= 200 && reqGameData.status < 300) {
			var stSplit = reqGameData.responseText.split("~");
			//console.log(reqGameData.responseText);		console.log(stSplit.length);
			if(stSplit.length>5 && stSplit[0]=="a") {
				if(stSplit[1]>0) { // Figur Daten erhalten
					commitZahlerstandFigur = stSplit[1];
					figurDatenServer2Browser(units, hintergrund,gridElemente, stSplit[2]);
				}
				if(stSplit[3]>0) { // Hintergrund Dateiname erhalten
					commitZahlerstandHintergrund = stSplit[3];
					hintergrundDateinameServer2Browser( hintergrund, stSplit[4]);
				}
				if(stSplit[5]>0) { // Würfel/Chat Daten erhalten
					commitZahlerstandWuerfel = stSplit[5];
					wuerfelDatenServer2Browser( guiElemente[wuerfelB],stSplit);
				}
			}
		} else {
			console.warn(reqGameData.statusText, reqGameData.responseText);
		}
	}

	// -----------------------------------------------------------------
	//  Server nach neuen Daten fragen
	var daten = "a~" + commitZahlerstandFigur +";"+ commitZahlerstandHintergrund +";"+ commitZahlerstandWuerfel;
	reqGameData.open("POST","webRPG_reqGameData.php"); // PHP Version
	// reqGameData.open("POST","../reqGameData"); // GOlang Version
	reqGameData.send(daten);
	// Antwort in Callback Funktion

	
	// -----------------------------------------------------------------
	// --------------------- paint() -----------------
	// -----------------------------------------------------------------
    function paint() {
        // beispielcode, hat problem mit scrollbalken
        //var mx = input.mouse.position.x - offset.left;
        //var my = input.mouse.position.y - offset.top;
        // versuch eines Fixes
		var offset = scene.dom.getBoundingClientRect();
        var mx = input.mouse.position.x - offset.left;
        var my = input.mouse.position.y - offset.top;
        var mOK=true; // wird false, sobald ein Objekt gefunden wurde; Realisieren von Ebenen für das GUI
        
        //
        // ------- left click -------                      
        //
        if(input.mousepressed) {  
			selCursor.position(mx,my) // Kollisionserkennung
			mOK=true; // wird false, sobald ein Objekt gefunden wurde; Realisieren von Ebenen für das GUI
			units_dragNdrop.nummer=-1;
			// ------- GUI = figuren_Aussehen_Auswahl ------- left click -------
			if (mOK && unitsAussehenEinAus==1 && units_selected>-1) {
				for (var i=0;i<64;i++) { 
					if(selCursor.collidesWith(unitsAussehen[i]) ) {
						mOK=false; // nicht weiter nach Kollisionen suchen
						unitsAussehenEinAus=0 ; // Anzeige ausschalten 
						unitsAussehen=figurenAussehenAuswahl_Anzeigen(unitsAussehen,guiElemente[0].x,guiElemente[0].y,false)
						console.log("Unit Aussehen =",i);
						units[units_selected].aussehen = i;
						// -> an Server senden
						var daten = "f~"+ units_selected +"~"  // Type "f" + FigurNr
						daten=daten+ figurDatenBrowser2Server( units[units_selected] ); 
						setGameData.open("POST","webRPG_setGameData.php");
						setGameData.send(daten);
					}
				}
			}
			// ------- GUI = Toolbar ------- left click -------
			for (var i=0;i<Ngui+1;i++) { 
               if( mOK && selCursor.collidesWith(guiElemente[i])) {
					mOK=false; // nicht weiter nach Kollisionen suchen
					switch(i) {
						case  0: toolbar_dragNdrop = true; break; // Toolbar verschieben
						// ----- Erste Zeile -----
						case  1: // Aussehen der Figur ändern
							if(unitsAussehenEinAus>0) {unitsAussehenEinAus=0; } else { unitsAussehenEinAus=1; }; // tooglen auf UnitsAussehen
							unitsAussehen=figurenAussehenAuswahl_Anzeigen(unitsAussehen,guiElemente[0].x,guiElemente[0].y,unitsAussehenEinAus);
							break;
						case  2: case 3: // unitsZoom
							if(units_selected>-1){
								units[units_selected] = toolbar_unitsZoom(i-1, units[units_selected] );
								// -> an Server senden
								var daten = "f~"+ units_selected +"~"  // Type "f" + FigurNr
								daten=daten+ figurDatenBrowser2Server( units[units_selected] ); 
								setGameData.open("POST","webRPG_setGameData.php");
								setGameData.send(daten);
							}
							break;
						//case 3: siehe case 2:
						case  4: // Figur in die Reihe zurück
							units[units_selected].zoom=2; // Originalgröße
							units[units_selected].position( units[units_selected].defaultPosX, units[units_selected].defaultPosY );
							// -> an Server senden
							var daten = "f~"+ units_selected +"~"  // Type "f" + FigurNr
							daten=daten+ figurDatenBrowser2Server( units[units_selected] ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten);
							break;
						case  5: // Blinken um Figuren zu finden
							if(units_blinken>0){units_blinken=-2}else{units_blinken=1};
							break; 
						case  6:  // => Cache leeren & neu laden!
							location.assign('webRPG_main.html');
								// ----- entweder im <header> der Webseite das Caching beeinflussen... -----
								// <meta http-equiv="Cache-Control" max-age=3600  />
								// <meta http-equiv="Cache-Control" content="no-cache" />
								// <meta http-equiv="Pragma" content="no-cache" />
								// <meta http-equiv="Expires" content="0" />
								// ----- oder -----
								//  don’t trust that those values work in all browsers so I use Jquery or Javascript (or PHP on the server side) 
								// to attach a random attribute to a filename so instead of calling "LOGO.GIF", I call "LOGO.GIF?id=938475761" 
								// They get the same image but it NEVER comes from their cache.
							break 
						case  7:  // Farbe der Würfeln bestimmen -> guiElemente[wuerfelB].farbe
							guiElemente = toolbar_wuerfelfarbe( guiElemente ); 
							break;
						case  8:  // Würfeln durchführen in eigener Funktion
							wuerfelBecher( guiElemente[wuerfelB], hintergrund ); 
							break;
						// ----- Zweite Zeile -----
						case  9: break;// Dateimanager
						case 10: case 11: // hintergrundZoom
							hintergrund = toolbar_hintergrundZoom(i-9, hintergrund );
							// -> an Server senden
							var daten = hintergrundDatenBrowser2Server( hintergrund ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten); // -> an Server senden
							break;
						//case 11: siehe case 10:
						case 12: // Grid An/ Aus
							if(gridElemente.EinAus) {
								gridElemente.EinAus=false; 
								gridElemente.position(0,2500);
								hintergrund.gridOnOff=0; // 0=off, 1=on
							} else {
								gridElemente.EinAus=true;
								gridElemente.position(256,0);
								hintergrund.gridOnOff=1; // 0=off, 1=on
							}; // tooglen
							var daten = hintergrundDatenBrowser2Server( hintergrund ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten); // -> an Server senden
							break;
						case 13: // Hintergrund nach rechts
							hintergrund.Xoff = hintergrund.Xoff -32;
							hintergrund.setX(hintergrund.Xoff); //  gespeichert in figure(Nunite)
							var daten = hintergrundDatenBrowser2Server( hintergrund ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten); // -> an Server senden
							break; 
						case 14: // Hintergrund nach links
							hintergrund.Xoff = hintergrund.Xoff +32;
							hintergrund.setX(hintergrund.Xoff); // gespeichert in figure(Nunite)
							var daten = hintergrundDatenBrowser2Server( hintergrund ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten); // -> an Server senden
							break; 
						case 15: // Hintergrund nach unten,
							hintergrund.Yoff = hintergrund.Yoff +32;
							hintergrund.setY(hintergrund.Yoff); // gespeichert in figure(Nunite)
							var daten = hintergrundDatenBrowser2Server( hintergrund ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten); // -> an Server senden
							break; 
						case 16: // Hintergrund nach oben
							hintergrund.Yoff = hintergrund.Yoff -32;
							hintergrund.setY(hintergrund.Yoff); // gespeichert in figure(Nunite)
							var daten = hintergrundDatenBrowser2Server( hintergrund ); 
							setGameData.open("POST","webRPG_setGameData.php");
							setGameData.send(daten); // -> an Server senden
							break; 
						default:
							break;					}
					break;
				}
			}
			// ------- Figuren auswählen------- left click -------
			for (var i=Nunits-1;i>=0;i--)  { // Rückwärts zählen damit Select der sichtbaren Reihenfolge entspricht
				if(mOK && selCursor.collidesWith(units[i])) {
					mOK=false; // nicht weiter nach Kollisionen suchen
					units_dragNdrop.nummer= i;
					units_dragNdrop.xOff = mx-units[units_dragNdrop.nummer].x;
					units_dragNdrop.yOff = my-units[units_dragNdrop.nummer].y;
					units_selected = i;
					break;
				}
			}
 			// ------- Streifen zum Zählen verschieben ------- left click ------- NUR LOKAL !
			for (var i=0;i<4;i++) { 
				if( mOK && selCursor.collidesWith(zaehlerElemente[i])) {
					mOK=false; // nicht weiter nach Kollisionen suchen
					zaehler_dragNdrop=i;
				}
			}
		} //endif (input.mousepressed)
		//
		// ---------- Ende vom drag & drop ----------
        //
        if(input.mousereleased) {
			if(units_dragNdrop.nummer>=0) { // Drag & Drop ist beendet -> an Server senden
				var daten = "f~"+ units_dragNdrop.nummer +"~"  // Type "f" + FigurNr
				daten=daten+ figurDatenBrowser2Server( units[units_dragNdrop.nummer] ); 
				setGameData.open("POST","webRPG_setGameData.php");
				setGameData.send(daten);
			}
            units_dragNdrop.nummer = -1;
			toolbar_dragNdrop = false;
			zaehler_dragNdrop=-1;
        } // endif (input.mousereleased)
        //
        // ------- UNITS wirklich bewegen -------
        //
        if(units_dragNdrop.nummer>-1) {//dragNdrop unit bewegen
			units[units_dragNdrop.nummer].dom.style.border  = '2px solid #bbb';
            if(mx>0 && my>0 && mx<gameWidth && my<gameHeight) {
				mx= mx-units_dragNdrop.xOff; 
				my= my-units_dragNdrop.yOff; 
				units[units_dragNdrop.nummer].position(mx,my); // Sprite an Maus binden
			} 
		} else if(toolbar_dragNdrop) {
			guiElemente = toolbar_DO_dragNdrop(guiElemente,mx,my, gameWidth, gameHeight);
			
		} else if(zaehler_dragNdrop>-1) {
			zaehlerElemente[zaehler_dragNdrop].position(mx-32,my-8);
			zaehlerElemente[zaehler_dragNdrop+8].position(mx-32,my+8);
		}else{
			timerReqGameData ++;
			if (timerReqGameData > 30) { // 10x 30 frames/s = 333ms
				timerReqGameData=0;
				//  Server nach neuen Daten fragen
				var daten = "a~" + commitZahlerstandFigur +"~"+ commitZahlerstandHintergrund +"~"+ commitZahlerstandWuerfel;
				reqGameData.open("POST","webRPG_reqGameData.php");
				reqGameData.send(daten);
				// Antwort in Callback Funktion
			}
		} 
		// ------- update malen ------- 
		// Hintergrund
		hintergrund.update();
		// Grid
		gridElemente.update();
		// zaehlerelmente
		for (var i=0;i<12;i++) {
			zaehlerElemente[i].update();
		}
  		// Toolbar & Würfelbeutel
		for (var i=0;i<18;i++) {
			guiElemente[i].update();
		}
		// Avatare = Figuren = units
		if(units_blinken>0) {
			for (var i=0;i<Nunits;i++) {
			// blinken
				if(units_blinken== 5) { units[i].dom.style.border  = '2px solid #f00'; }; 
				if(units_blinken==10) { units[i].dom.style.border  = '2px solid #ff0'; };
				if(units_blinken==15) { units[i].dom.style.border  = '2px solid #0f0'; }; 
				if(units_blinken==20) { units[i].dom.style.border  = '2px solid #0ff'; };
				if(units_blinken==25) { units[i].dom.style.border  = '2px solid #00f'; }; 
				if(units_blinken==30) { units[i].dom.style.border  = '2px solid #f0f'; };
			}
			units_blinken+=1;
			if(units_blinken>30) { units_blinken=1; };
		} else {
			for (var i=0;i<Nunits;i++) { units[i].dom.style.border = ''; }
			if (units_selected>-1) { units[units_selected].dom.style.border  = '2px solid #bbb';}
		}
		// update
		for (var i=0;i<Nunits;i++) {
			units[i].update();
		}
	}; // end function paint() 
	// -----------------------------------------------------------------
	// -------- starte GUI mit "ticker" -------
	// -----------------------------------------------------------------
    var ticker = scene.Ticker(paint, {tickDuration:33}); // alle 33ms neu aufrufen => 30.3030 Hz
    ticker.run();
    console.log( 'webRPG lauft');  
    

}; // end window.onload = function() {

// --------------------------------------------------------------------- 
// returns a random number between min and max (both included):
// --------------------------------------------------------------------- 
function getRndInteger( max) {
	var min = 1
  return Math.floor(Math.random() * (max - min + 1) ) + min;
}


	
// --------------------------------------------------------------------- 
//  Komunikation mit dem Server --- aktuelle Position oder Würfelwert setzen
// --------------------------------------------------------------------- 
// Datenformat:
// 1.Ziele: 'f' oder 'h' oder 'd' je nachdem ob Figur oder Hintergrund oder Würfeldaten gesendet werden
// Wenn 'f': 2. Zeile: figurNr  Welche Figur wurde bewegt
// Wenn 'f': 3. Zeile: Daten der Figur im Format zzXXXyyy : zz=Zoom ; xxx & yyy Position in Pixeln
// wenn 'h': 2. Zeile: Sting mit dem Dateinamen des Hintergrundes
// wenn 'd': 2. Zeile: Sting der neuen Würfeldaten
var setGameData = new XMLHttpRequest();
setGameData.addEventListener('load', setGameData_callback);
function setGameData_callback() {
	if (setGameData.status >= 200 && setGameData.status < 300) {
			// console.log(setGameData.responseText);
	} else {
		console.warn(setGameData.statusText, setGameData.responseText);
	}
};
	

// --------------------------------------------------------------------- 
//  Würfelbot
// --------------------------------------------------------------------- 
function wuerfelBecher(wuerfel, hintergrund) {
	var wuerfelstr = wuerfel.farbe; 
	var wuerfelAnz =0;
	var wuerfelArt =0;
	var wurfsumme=0; var wurf=0; var wuerfelGrosserAlsAnzahl=0; var wuerfelGrosserAls=-1;
	if (user != "") {wuerfelstr=wuerfelstr+user+": "};
	// --- Nutzer Fragen ---
	var antwort = prompt('Welche Würfel sollen geworfen werden? max. 20w100 oder 4wF oder 6w6>4\n# Nachricht\n/u Username   /d Defaultwürfel   /h x,y,z Hintergrund (/h 256,0,1)', defaultWstring );
	if (antwort !== null) {
		if (antwort.startsWith("/") ) { // --- ist es ein Befehl? ---
			if (antwort.substr(1,1) == "u") { 
				user = antwort.substr(2).trim();
				sessionStorage.setItem('user', user);
			} else if (antwort.substr(1,1) == "d") {
				defaultWstring = antwort.substr(2).trim();
				sessionStorage.setItem('defaultWstring', defaultWstring);
			} else if (antwort.substr(1,1) == "h") {
				var h = antwort.substr(2).trim() . split(','); // in x,y,z Zerlegen
				//wuerfelstr = wuerfelstr + 'Hintergrund x='+h[0]+' y='+h[1]+' zoom='+h[2];
				hintergrund.Xoff=h[0];
				hintergrund.Yoff=h[1];
				hintergrund.zoom = Math.round( h[2]*10 )-5;
				if (hintergrund.zoom<0){hintergrund.zoom=0;};
				if (hintergrund.zoom>15){hintergrund.zoom=15;};
				// -> an Server senden
				var daten = hintergrundDatenBrowser2Server( hintergrund ); 
				setGameData.open("POST","webRPG_setGameData.php");
				setGameData.send(daten); // -> an Server senden
			}
		} else { // ------- es ist kein Befehl -------
			if (antwort.startsWith("#") || antwort.startsWith("!") ) { // Chat?
				wuerfelstr= wuerfelstr + antwort.replaceAll("~"," "); // "~" ist Trennzeichen meines Systems -> ersetzen!
			} else { // oder Würfel
				// --- wuerfelGrosserAls --- vorhanden?
				if (antwort.search('>') >2) { 
					wuerfelGrosserAls = antwort.substr( antwort.search('>')+1 );
					antwort = antwort.substr( 0, antwort.search('>') );
				}
				// wieviel und welche Würfel?
				var antwMitW = antwort.split('W',2);
				var antwMitw = antwort.split('w',2);
				var antwMitD = antwort.split('D',2);
				var antwMitd = antwort.split('d',2);
				if(antwMitW.length==2) {
					 wuerfelAnz = antwMitW[0] ; wuerfelArt = antwMitW[1];
				}
				if(antwMitw.length==2) {
					 wuerfelAnz = antwMitw[0] ; wuerfelArt = antwMitw[1];
				}
				if(antwMitD.length==2) {
					 wuerfelAnz = antwMitD[0] ; wuerfelArt = antwMitD[1];
				}
				if(antwMitd.length==2) {
					 wuerfelAnz = antwMitd[0] ; wuerfelArt = antwMitd[1];
				}
				// --- hier wird gewürfelt ---
				if (wuerfelArt>0 && wuerfelArt<101 && wuerfelAnz>0 && wuerfelAnz<21 ) {
					// Würfelart und Anzahl ist OK
					wuerfelstr = wuerfelstr + wuerfelAnz +'w'+ wuerfelArt +':';
					for (var i=0;i<wuerfelAnz;i++) {
						wurf=getRndInteger(wuerfelArt);
						wurfsumme=wurfsumme+wurf;
						wuerfelstr = wuerfelstr + ', '+ wurf;
						if (wurf > wuerfelGrosserAls ) { wuerfelGrosserAlsAnzahl += 1;}
					}
					wuerfelstr = wuerfelstr + ' = '+ wurfsumme;
					if (wuerfelGrosserAls>0) { wuerfelstr = wuerfelstr + ' >'+ wuerfelGrosserAls + ': ' + wuerfelGrosserAlsAnzahl; }
				} //endif (wuerfelArt>0 && wuerfelArt<101 && wuerfelAnz>0 && wuerfelAnz<21 ) 
				// --- Fatewürfel "f" oder "F"
				if ( (wuerfelArt=="f" || wuerfelArt=="F") && wuerfelAnz>0 && wuerfelAnz<21 ) {
					// Würfelart und Anzahl ist OK
					wuerfelstr = wuerfelstr + wuerfelAnz +'wF:';
					for (var i=0;i<wuerfelAnz;i++) {
						wurf=getRndInteger(3);
						wurfsumme=wurfsumme+wurf-2;
						if(wurf==1) { wuerfelstr = wuerfelstr + ', -'; }
						if(wurf==2) { wuerfelstr = wuerfelstr + ', o'; }
						if(wurf==3) { wuerfelstr = wuerfelstr + ', +'; }
					};
					wuerfelstr = wuerfelstr + ' = '+ wurfsumme;
				} //endif Fatewürfel
			} // endif // oder Würfel
			// ------- Daten an den Server senden ------- 
			var daten = 'd~'+ wuerfelstr  // Type "d" + Würfel string versenden
			setGameData.open("POST","webRPG_setGameData.php"); // PHP Version
			// setGameData.open("POST","../setGameData"); // GOlang Version
			setGameData.send(daten);
		} // endif // --- ist es ein Befehl? ---
	} // endif (antwort !== null)
}

// ---------------------------------------------------------
function wuerfelDatenServer2Browser(wuerfel, wuerfelstr) {
// ---------------------------------------------------------
	//console.log( 'wuerfelDatenServer2Browser:');  	console.log( wuerfelstr);
	var historieNeu= '';
	for (var i=NwuerfelStart; i<wuerfelstr.length; i++) {
		var farbStr= 'style="color:'; // "background-color" oder "color"
		switch(wuerfelstr[i].substring(0,1) ) {
			case 'b': farbStr= farbStr+'#00F"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // blau
			case 'g': farbStr= farbStr+'#0D0"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // grün
			case 'r': farbStr= farbStr+'#D00"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // rot
			case 'y': farbStr= farbStr+'#DD0"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // gelb
			case 'c': farbStr= farbStr+'#F0F"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // cyan
			case 'm': farbStr= farbStr+'#0DD"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // magenta
			case 'x': farbStr= farbStr+'#888"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // grau 
			case 'k': farbStr= farbStr+'#000"'; wuerfelstr[i]=wuerfelstr[i].substring(1); break; // schwarz 
			default : farbStr= farbStr+'#000"'; wuerfelstr[i]='';	break; // schwarz & Ausgabe unterdrücken  //'### '+wuerfelstr[i];	
		}
		if (wuerfelstr[i].length>0) {
			historieNeu = historieNeu+'<div class="wuerfel" ' +farbStr+ '>' + wuerfelstr[i] + '<br></div>';
		}
		// --- Ausgabe ---
	};
	wuerfel.dom.innerHTML = historieNeu;
};

// ---------------------------------------------------------
function hintergrundDateinameServer2Browser( hintergrund, antwort) {
//	console.log( 'hintergrundDateinameServer2Browser:');  	console.log( antwort);  
	hintergrund.nr=antwort.trim();
	console.log( 'hintergrundDateinameServer2Browser:');  	console.log( 'daten/'+hintergrund.nr  );  
	hintergrund.loadImg( 'daten/'+hintergrund.nr , true);
};
// ---------------------------------------------------------


// ---------------------------------------------------------
// --- Figuren: Antwort vom Server in Browser ausgeben
// ---------------------------------------------------------
// 32 Bit verfügbar
//   4 Bit Sprite-Aussehen // 4 Bit Zoom // 12 Bit : x-Koordinate // 10 Bit y-Koordinate // 2 Bit Sprite-Aussehen
// ---------------------------------------------------------
function figurDatenServer2Browser(units, hintergrund,gridElemente, antwort) {
// ---------------------------------------------------------
	var index=0;
	// console.log( 'figurDatenServer2Browser');  	console.log( antwort.length);  
	if(antwort.length == (Nunits+1)*8+1) { // + newline !?! (32 Figuren+Hintergrund)
		for (var i=0; i<Nunits; i++) {
			// 32Bit HEX Zerlegen
			var a = parseInt( antwort.substring(index+0,index+1), 16);
			units[i].zoom = 	parseInt( antwort.substring(index+1,index+2), 16);
			var x = 			parseInt( antwort.substring(index+2,index+5), 16);
			var y = 			parseInt( antwort.substring(index+5,index+8), 16);
			if (y>2047) {y=y-2048; a=a+32;}; // Bit 12 von y nach Bit 6 von a 
			if (y>1023) {y=y-1023; a=a+16;}; // Bit 11 von y nach Bit 5 von a
			// aussehen
			units[i].aussehen = a;
			if(a<32) { // Unterscheidung Avatare/ Marker 
				units[i].setXOffset( 0); 
				units[i].setYOffset(32*a);
			} else {
				units[i].setXOffset(32); 
				units[i].setYOffset(32*a);
			}
			//zoom
			var zoom = units[i].zoom ;
			if(zoom == 0 ){zoom=16};
			units[i].scale(zoom/2);
			units[i].shape = {x:16-32*zoom/4, y:16-32*zoom/4, w:32*zoom/2, h:32*zoom/2}; // boundingbox anpassen!
			units[i].position(x,y);
			index=index+8;
		}
		// ------- (Nunits+1) ist Hintergrund !  -------
		// 32Bit HEX Zerlegen
		var a = parseInt( antwort.substring(index+0,index+1), 16);
		var zoom = 	parseInt( antwort.substring(index+1,index+2), 16);
		var x = 			parseInt( antwort.substring(index+2,index+5), 16);
		var y = 			parseInt( antwort.substring(index+5,index+8), 16);
		if (y>2047) {y=y-2048; a=a+32;}; // Bit 12 von y nach Bit 6 von a 
		if (y>1023) {y=y-1023; a=a+16;}; // Bit 11 von y nach Bit 5 von a
		// Position
		hintergrund.Xoff = (x-256)*8;
		hintergrund.setX( hintergrund.Xoff );
		hintergrund.Yoff = (y-256)*8;
		hintergrund.setY(hintergrund.Yoff);
		hintergrund.zoom=zoom; 	hintergrund.scale(0.5+zoom*0.10);
		hintergrund.gridOnOff=a;
		if(hintergrund.gridOnOff==0) {
			gridElemente.EinAus=false; 
			gridElemente.position(0,2500);
		} else {
			gridElemente.EinAus=true;
			gridElemente.position(256,0);
		}; // tooglen
		// Aussehen -- in eigenen Dateinamen Teil ausgelagert				
	}
}

// ---------------------------------------------------------
// --- Figuren: Daten für Server aufbereiten
// ---------------------------------------------------------
// 32 Bit verfügbar
//   4 Bit Sprite aussehen // 4 Bit Zoom // 12 Bit : x-Koordinate // 10 Bit y-Koordinate // 2 Bit Sprite aussehen
function figurDatenBrowser2Server(unitX) {
	var x=Math.round(unitX.x );
	var y=Math.round(unitX.y );
	var a=unitX.aussehen;
	if (a>31) {a=a-32; y=y+2048;}; // Bit 6 von a nach Bit 12 von y 
	if (a>15) {a=a-16; y=y+1024;}; // Bit 5 von a nach Bit 11 von y
	var hexA = a.toString(16); // Prüfung auf z>= 0 und z<16 und int() fehlen...
	var hexZ = unitX.zoom.toString(16);	 // Prüfung auf z>= 0 und z<16 und int() fehlen...
	var hexX = x.toString(16); 	// Prüfung auf x>= 0 und x<4096 
	var hexY = y.toString(16); 	// Prüfung auf y>= 0 und y<4096
	//console.log( "A:"+unitX.aussehen+" hexA"+hexA);
	//console.log( "Set y="+unitX.y+" hexY="+dreiStellen(hexY) );
	return (hexA + hexZ + dreiStellen(hexX) + dreiStellen(hexY) );
}
function dreiStellen( eingabe ) {
	var ausgabe='';
	if( eingabe.length ==1 ) { ausgabe="00"+eingabe};
	if( eingabe.length ==2 ) { ausgabe="0"+eingabe};
	if( eingabe.length ==3 ) { ausgabe=eingabe};
	if( eingabe.length <1 || eingabe.length >3) { ausgabe="000" }; 
	return ausgabe
}

// ---------------------------------------------------------
// --- Hintergrund: Daten für Server aufbereiten
// ---------------------------------------------------------
function hintergrundDatenBrowser2Server( hintergrund ) {
	//  Hintergrund jetzt via Dateiname ausgewählt!
	var x=Math.round( hintergrund.Xoff/8+256 );
	var y=Math.round( hintergrund.Yoff/8+256 );
	if (x<0){x=0}; if(x>2047){x=2047};
	if (y<0){y=0}; if(y>1023){y=1023};
	var a=hintergrund.gridOnOff;
	var zoom=hintergrund.zoom;
	if (a>31) {a=a-32; y=y+2048;}; // Bit 6 von a nach Bit 12 von y 
	if (a>15) {a=a-16; y=y+1024;}; // Bit 5 von a nach Bit 11 von y
	var hexA = a.toString(16); // Prüfung auf a>= 0 und a<16 und int() fehlen...
	var hexZ = zoom.toString(16);	 // Prüfung auf z>= 0 und z<16 und int() fehlen...
	var hexX = x.toString(16); 	// Prüfung auf x>= 0 und x<4096 
	var hexY = y.toString(16); 	// Prüfung auf y>= 0 und y<4096
	//console.log( "A:"+hintergrund.gridOnOff+" hexA"+hexA);
	//console.log( "Set y="+unitX.y+" hexY="+dreiStellen(hexY) );
	var daten = "f~"+ (Nunits) +"~"  // Type "f" + FigurNr // FigurNr = Nunits => Hintergrund
	daten=daten+ (hexA + hexZ + dreiStellen(hexX) + dreiStellen(hexY) );

return  daten
}

