<?php
/*
 * rpgWebGUI_reqGameData.php
 * 
 * Copyright 2021 Joerg <kuma@sffi.eu>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */

// --------------------------------------------------------------------- 
//  Server nach neuen Daten fragen  --- hier wird die Antworten erstellt
// --------------------------------------------------------------------- 
// === Anfrage: ===  
// Flag; commit Zähler Figur ; Commit Zähler Würfelstring
// === Antwort ist: ===
// Flag ; commit Zählerstand Figur ; 32 * units[] ; Commit Zählerstand Hintergrund ; Dateiname Hintergrund ; Commit Zählerstand Würfelstring ; 11 * Würfelstring
// 33 * units[] Objekte: 'zzXXXyyy' zz: Zoomfaktor*4, XXX & yyy Koordinaten/2
// Würfel String (TODO: 32 * 'DDvvXXyy' DD: Würfeltyp W20, vv: geworfener Wert, XX & yy Koordinaten /16


// --------------------------------------------------------------------- 
// Daten die via POST vom Webserver gesendet wurden:
$daten = file_get_contents('php://input');
// Anfrage:  Flag; commit Zähler Figur ; Commit Zähler Würfelstring
$datenTeile = explode('~', $daten); // Zerlegen

// printf("\n%s\n", ' Game Daten Out');

if(count($datenTeile) == 4 && $datenTeile[0] == 'a') {
	if(file_exists('webRPG_gameDaten.txt')){
	// --------------------------------------------------------------------- 
	// get LOCK -- damit lesen und schrieben von mehreren Clients sich nicht stören können.
	$fp_lock = fopen("lock.txt", "r+");
	// this will wait until lock is acquired
	// for "no waiting" use: LOCK_EX | LOCK_NB
	if (flock($fp_lock, LOCK_EX)) {  // acquire an exclusive lock
		// --------------------- LOCK erhalten ... SAFE TO WORK HERE ---------------------
		$gameDaten = file('webRPG_gameDaten.txt'); // Datei in einem Rutsch lesen
		// --------------------- LOCK zurückgeben ---------------------
		// LOCK zurückgeben
		flock($fp_lock, LOCK_UN);    // release the lock
	} else {
		// only reached in case of a lock is nonblocking or general error
		echo "Couldn't get the lock!";
	}
	fclose($fp_lock);
	// printf("Lock überlebt\n");
	// --------------------------------------------------------------------- 
	// Antwort erstellen:
		if(count($gameDaten)==16) { // es müssen genau 16 Zeilen sein, ansonsten schreibt gerade setGameDaten oder ein Problem!
			// sind neue Figuren-Daten vorhanden ?
			if( (int)$gameDaten[0] > (int)$datenTeile[1] ){ // ja, neue vorhanden -> übertragen
				printf('a~%d~%s', (int)$gameDaten[0], $gameDaten[1] );
			} else { // nein -> keine Daten senden
				printf('a~0~');
			}
			// sind neue Hintergrund-Daten vorhanden ?
			if( (int)$gameDaten[2] > (int)$datenTeile[2] ){ // ja, neue vorhanden -> übertragen
				printf('~%d~%s', (int)$gameDaten[2], $gameDaten[3] );
			} else { // nein -> keine Daten senden	
				printf( '~0~' );
			}
			// sind neue Wuerfel-Daten vorhanden ?
			if( (int)$gameDaten[4] > (int)$datenTeile[3] ){ // ja, neue vorhanden -> übertragen
				printf('~%d~%s', (int)$gameDaten[4], $gameDaten[5] );
				printf('~%s~%s~%s~%s~%s', $gameDaten[6] ,$gameDaten[7] ,$gameDaten[8] ,$gameDaten[9] ,$gameDaten[10] );
				printf('~%s~%s~%s~%s~%s', $gameDaten[11],$gameDaten[12],$gameDaten[13],$gameDaten[14],$gameDaten[15] );
			} else { // nein -> keine Daten senden	
				printf( '~0~' );
			}
		}
	}
}


/*
printf("\n%s\n", ' Game Daten Out');
printf("gameDaten[0] %d\n",(int)$gameDaten[0]);
printf("datenTeile[1] %d\n",(int)$datenTeile[1]);
printf("%s\n",sprintf('a;%d;%s', (int)$gameDaten[0], $gameDaten[1] ) );
printf("%d\n", count($gameDaten) );
*/


?>
