<?php
/*
 * rpgWebGUI_reqGameData.php
 * 
 * Copyright 2020 Joerg <kuma@sffi.eu>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 * 
 * 
 */

// --------------------------------------------------------------------- 
//  Komunikation mit dem Server --- aktuelle Position oder Würfelwert setzen
//  ------- setGameData : javascript sendet mir neue Daten
// --------------------------------------------------------------------- 
// Datenformat:
// 1.Ziele: 'f' oder 'h' oder 'd' je nachdem ob Figur oder Hintergrund oder Würfeldaten gesendet werden
// Wenn 'f': 2. Zeile: figurNr  Welche Figur wurde bewegt
// Wenn 'f': 3. Zeile: Daten der Figur im Format AzXXXyyy : A=Aussehen (+2Bit vom letzten y); z=Zoom ; xxx & yyy Position in Pixeln
// wenn 'h': 2. Zeile: Sting mit dem Dateinamen des Hintergrundes
// wenn 'd': 2. Zeile: Sting der neuen Würfeldaten

// --------------------------------------------------------------------- 
// Daten die via POST vom Webserver gesendet wurden:
$daten = file_get_contents('php://input');
$datenTeile = explode('~', $daten); // Zerlegen

// --------------------------------------------------------------------- 
// get LOCK -- damit lesen und schrieben von mehreren Clients sich nicht stören können.
$fp_lock = fopen("lock.txt", "r+");
// this will wait until lock is acquired
// for "no waiting" use: LOCK_EX | LOCK_NB
if (flock($fp_lock, LOCK_EX)) {  // acquire an exclusive lock
	// --------------------- LOCK erhalten ... SAFE TO WORK HERE ---------------------
	// bisherige Daten aus Datei lesen
	$gameDaten = file('webRPG_gameDaten.txt'); // Datei in einem Rutsch lesen
	
	$readOK=false;
	if(file_exists('webRPG_gameDaten.txt')){
		$gameDaten = file('webRPG_gameDaten.txt'); // Datei in eim rutsch lesen
		if(count($gameDaten) ==16) { // es müssen genau 16 Zeilen sein, ansonsten schreibt gerade setGameDaten oder ein Problem!
			$readOK=true;
		}
	}
	if(readOK==false) {
		echo "Datei mit dem GameDaten ist korrupt? Schreibe Default";
		// 'Datei' anlegen, wird nur geschrieben, wenn Server ein legales Update sendet
		$gameDaten[0]=sprintf("1\n"); // Figuren
		$gameDaten[1]='';
		for ($ii=0; $ii<32; $ii++) {
			$gameDaten[1]= sprintf('%s01002%03d', $gameDaten[1] , $ii*8); // Achtung bei umstellung auf HEX ist das nicht mehr schön
		}
		$gameDaten[1]= sprintf('%s01120101\n', $gameDaten[1] ); // Hintergrund als 33. Figur
		$gameDaten[2]= sprintf("1\n"); // Hintergrund
		$gameDaten[3]='hintergrund0.jpg';
		$gameDaten[4]= sprintf("1\n"); // Würfel/ Chat
		$handle = fopen('webRPG_gameDaten.txt', 'w'); // zum schreiben öffnen & Inhalt löschen
		fwrite($handle, $gameDaten[0]);
		fwrite($handle, $gameDaten[1]);
		fwrite($handle, $gameDaten[2]);
		fwrite($handle, $gameDaten[3]);
		fwrite($handle, $gameDaten[4]);
		for ($ii=0; $ii<11; $ii++) {
			fwrite($handle, 'k ...'); // fwrite($handle, 'k ...');
		}
		fclose($handle);
	}   

	// --------------------- Figuren Daten Update --------------------- 
	if(count($datenTeile) == 3 && $datenTeile[0] == 'f') {
		$figurNr=(int)$datenTeile[1];
		$figurDaten=(string)$datenTeile[2];
		// replace mit RegExpressions preg_replace($pattern, $replacement, $string);
		//	$figurDaten=preg_replace('[^0-9ABCDEF]+', '', $figurDaten);  // alles außer '0-9ABCDEF' löschen
		if( strlen($figurDaten) == 8 && $figurNr >= 0 && $figurNr<33) {
			// Valide Daten => an der richtigen Stelle einfügen
			// substr ( string $string , int $start [, int $length ] ) : string|false
			$gameFig1= substr( $gameDaten[1] , 0, $figurNr*8 );
			$gameFig2= substr( $gameDaten[1] , ($figurNr+1)*8 ); // bis zum Ende
			$gameDaten[1] = sprintf("%s%s%s", $gameFig1, $figurDaten ,$gameFig2); // -- enthält $gameFig2 IMMER ein '\n' !?!
			// commitZaehler
			$gameDaten[0] = sprintf("%d\n", (int)$gameDaten[0] +1 );
			// neue Daten in Datei schreiben
			$handle = fopen('webRPG_gameDaten.txt', 'w'); // zum schreiben öffnen & Inhalt löschen
			fwrite($handle, $gameDaten[0]);
			fwrite($handle, $gameDaten[1]);
			fwrite($handle, $gameDaten[2]);
			fwrite($handle, $gameDaten[3]);
			fwrite($handle, $gameDaten[4]);
			for ($ii=0; $ii<11; $ii++) {
				fwrite($handle, $gameDaten[5+$ii]);
			}
			fclose($handle);
		}
	}
	// --------------------- Hintergrund Dateiname Update --------------------- 
	//
	// Dateimanage kehrt ins webRPG_main.html zurück und von dort wird diese Funktion aufgerufen
	if(count($datenTeile) == 2 && $datenTeile[0] == 'h') {
		$hintergrundDaten=(string)$datenTeile[1];
		$hintergrundDaten=test_input($hintergrundDaten); // Daten = String prüfen ob er sicher ist 
	    if( strlen($hintergrundDaten) > 127) {
			$hintergrundDaten="hintergrund0.jpg";
		}
		$gameDaten[3]=sprintf("%s\n", $hintergrundDaten);
		// commitZaehler
		$gameDaten[2] = sprintf("%d\n", (int)$gameDaten[2] +1 );
		// neue Daten in Datei schreiben
		$handle = fopen('webRPG_gameDaten.txt', 'w'); // zum schreiben öffnen & Inhalt löschen
		fwrite($handle, $gameDaten[0]);
		fwrite($handle, $gameDaten[1]);
		fwrite($handle, $gameDaten[2]);
		fwrite($handle, $gameDaten[3]);
		fwrite($handle, $gameDaten[4]);
		for ($ii=0; $ii<11; $ii++) {
			fwrite($handle, $gameDaten[5+$ii]);
		}
		fclose($handle);
	}
	// --------------------- Würfel/ Chat Update --------------------- 
	if(count($datenTeile) == 2 && $datenTeile[0] == 'd') {
		// aufbereiten
		$wuerfelDaten=(string)$datenTeile[1];
		$wuerfelDaten=test_input($wuerfelDaten); // Daten = String prüfen ob er sicher ist 
	    if( strlen($wuerfelDaten) > 127) {
			$wuerfelDaten="r wuerfelDaten zu lang (mehr als 127 Zeichen)\n";
		}
	    if( strlen($wuerfelDaten) < 2) {
			$wuerfelDaten="k ...\n";
		}
		// commitZaehler
		$gameDaten[4] = sprintf("%d\n", (int)$gameDaten[4] +1 );
		// neue Daten in Datei schreiben
		$handle = fopen('webRPG_gameDaten.txt', 'w'); // zum schreiben öffnen & Inhalt löschen
		fwrite($handle, $gameDaten[0]);
		fwrite($handle, $gameDaten[1]);
		fwrite($handle, $gameDaten[2]);
		fwrite($handle, $gameDaten[3]);
		fwrite($handle, $gameDaten[4]);
		for ($ii=1; $ii<11; $ii++) { // $ii=1 weil ich die oberste Zeile lösche!
			fwrite($handle, $gameDaten[5+$ii]);
		}
		fwrite($handle, "$wuerfelDaten\n");
		fclose($handle);
	}	
	// --------------------- LOCK zurückgeben ---------------------
	// LOCK zurückgeben
	flock($fp_lock, LOCK_UN);    // release the lock
} else {
	// only reached in case of a lock is nonblocking or general error
	echo "Couldn't get the lock!";
}
fclose($fp_lock);

// Rückmeldung an Webbrowser
echo 'OK';

// --------------------- Funktion um eingabedaten zu prüfen ---------------------

function test_input($data) {
	$data = trim($data);
	//$data = stripslashes($data);
	$data = htmlspecialchars($data); // erzeugt aus ">" ein "&gt;" und ähnliches
	$data = str_replace("~", "", $data); // ich verwende "~" um meine Felder zu trennen :( 
	return $data;
	/*
	$name = test_input($_POST["name"]);
	if (!preg_match("/^[a-zA-Z-' ]*$/",$name)) {
		$nameErr = "Only letters and white space allowed";
	}
	*/
}

// --------------------------- MUELL und DEBUG zeug ---------------

/*
printf("strrep %s\n", $wuerfelDaten); 
 
printf("\n%s\n", ' Game Daten Out');
printf("%s",$gameDaten[0]);
printf("%s",$gameDaten[1]);
printf("%s",$gameDaten[2]);
printf("%s",$gameDaten[3]);
 
printf("%s\n", ' Game Daten In');
printf("%s",$gameDaten[0]);
printf("%s",$gameDaten[1]);
printf("%s",$gameDaten[2]);
printf("%s",$gameDaten[3]);
printf("%s",$gameDaten[4]);
printf("%s",$gameDaten[5]);
printf("%s",$gameDaten[15]);
printf("\n");
printf("%s\n", ' Vom Web:');
printf("%d\n", $datenTeile[1] );
printf("%s\n", $datenTeile[2] );
*/
//var_dump(count($teile));

?>
